//#############################################################################
//#
//#   Return to Blockland - Version 4
//#
//#   -------------------------------------------------------------------------
//#
//#      $Rev: 266 $
//#      $Date: 2010-08-04 07:29:41 +0100 (Wed, 04 Aug 2010) $
//#      $Author: Ephialtes $
//#      $URL: http://svn.returntoblockland.com/code/branches/4000/support/xmlParser.cs $
//#
//#      $Id: xmlParser.cs 266 2010-08-04 06:29:41Z Ephialtes $
//#
//#   -------------------------------------------------------------------------
//#
//#   Support / Overlay
//#
//#############################################################################
//Register that this module has been loaded
$RTB::Support::Overlay = 1;

//*********************************************************
//* Functionality
//*********************************************************
//- RTB_toggleOverlay (toggles the rtb overlay)
function RTB_toggleOverlay(%trigger)
{
   if(%trigger)
      return;
   
   RTB_Overlay.toggleOverlay();
}

//- RTB_escapeOverlay (escapes the rtb overlay)
function RTB_escapeOverlay(%trigger)
{
   if(%trigger)
      return;
   
   RTB_Overlay.escapeOverlay();
}

//- RTB_Overlay::toggleOverlay (toggles the rtb overlay)
function RTB_Overlay::toggleOverlay(%this)
{
   if(%this.isAwake())
      %this.fadeOut();
   else
      %this.fadeIn();
}

//- RTB_Overlay::fadeIn (fades the overlay into view)
function RTB_Overlay::fadeIn(%this)
{
   Canvas.pushDialog(%this);
   
   for(%i=0;%i<%this.getCount();%i++)
   {
      %ctrl = %this.getObject(%i);
      if(%ctrl.getName() !$= "")
         if(isFunction(%ctrl.getName(),"onWake"))
            %ctrl.onWake();
   }
}

//- RTB_Overlay::fadeOut (fades the overlay out of view)
function RTB_Overlay::fadeOut(%this)
{
   Canvas.popDialog(%this);
   
   for(%i=0;%i<%this.getCount();%i++)
   {
      %ctrl = %this.getObject(%i);
      if(%ctrl.getName() !$= "")
         if(isFunction(%ctrl.getName(),"onWake"))
            %ctrl.onSleep();
   }
}

//- RTB_Overlay::escape (closes windows/overlay)
function RTB_Overlay::escapeOverlay(%this)
{
   if(RTB_Options.isAwake() && RTBCO_OV_RemapSwatch.isVisible())
   {
      RTBCO_OV_RemapSwatch.setVisible(false);
      RTBCO_OV_Remap.delete();
      return;
   }
   
   if(!RTBCO_getPref("OV::EscapeClose"))
   {
      %this.fadeOut();
      return;
   }
   
   for(%i=%this.getCount()-1;%i>=0;%i--)
   {
      %window = %this.getObject(%i);
      if(%window.getClassName() $= "GuiWindowCtrl" && %window.isVisible())
         break;
   }
   
   if(%i < 0)
   {
      %this.fadeOut();
      return;
   }
   
   if(%window.overlayCloseCommand !$= "")
      eval(%window.overlayCloseCommand);
   else
      eval(%window.closeCommand);
}

//*********************************************************
//* Callbacks
//*********************************************************
//- RTB_Overlay::onWake (makes sure all ctrls fit on the overlay)
function RTB_Overlay::onWake(%this)
{
   %xDim = getWord(getRes(), 0);
   %yDim = getWord(getRes(), 1);
   
   GlobalActionMap.bind("keyboard","escape","RTB_escapeOverlay");
}

//- RTB_Overlay::onSleep (does random things)
function RTB_Overlay::onSleep(%this)
{
   if(AddOnsGui.isAwake())
      AddOnsGui.onWake();
      
   GlobalActionMap.unbind("keyboard","escape");

   RTBCO_Save();
}

//*********************************************************
//* Usage
//*********************************************************
//- RTB_Overlay::push (sets ctrl to visible on overlay)
function RTB_Overlay::push(%this,%ctrl)
{
   if(%this.isMember(%ctrl))
   {
      %ctrl.setVisible(true);
      %ctrl.onWake();
      
      %this.pushToBack(%ctrl);
   }
}

//- RTB_Overlay::toggle (toggles ctrl invisibility)
function RTB_Overlay::toggle(%this,%ctrl)
{
   if(%this.isMember(%ctrl))
   {
      if(%ctrl.isVisible())
      {
         %ctrl.setVisible(false);
         %ctrl.onSleep();
      }
      else
      {
         %ctrl.setVisible(true);
         %ctrl.onWake();
         
         %this.pushToBack(%ctrl);
      }
   }
}

//- RTB_Overlay::pop (sets ctrl to invisible on overlay)
function RTB_Overlay::pop(%this,%ctrl)
{
   if(%this.isMember(%ctrl))
   {
      %ctrl.setVisible(false);
      %ctrl.onSleep();
   }
}

//*********************************************************
//* Key Binds
//*********************************************************
GlobalActionMap.bind(getField(RTBCO_getPref("OV::OverlayKeybind"),0),getField(RTBCO_getPref("OV::OverlayKeybind"),1),"RTB_toggleOverlay");

//- Unbind RTB v3 IRC
%binding = moveMap.getBinding("RTBIC_toggleIRC");
if(%binding)
   moveMap.unbind(getField(%binding,0),getField(%binding,1));
